Merge v1.0 branch into master
[osm/RO.git] / scripts / install-openmano.sh
1 #!/bin/bash
2
3 ##
4 # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5 # This file is part of openmano
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License"); you may
9 # not use this file except in compliance with the License. You may obtain
10 # a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16 # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17 # License for the specific language governing permissions and limitations
18 # under the License.
19 #
20 # For those usages not covered by the Apache License, Version 2.0 please
21 # contact with: nfvlabs@tid.es
22 ##
23
24 #ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7
25 #Get needed packages, source code and configure to run openmano
26 #Ask for database user and password if not provided
27
28 function usage(){
29 echo -e "usage: sudo $0 [OPTIONS]"
30 echo -e "Install last stable source code in ./openmano and the needed packages"
31 echo -e "On a Ubuntu 16.04 it configures openmano as a service"
32 echo -e " OPTIONS"
33 echo -e " -u USER: database admin user. 'root' by default. Prompts if needed"
34 echo -e " -p PASS: database admin password to be used or installed. Prompts if needed"
35 echo -e " -q --quiet: install in unattended mode"
36 echo -e " -h --help: show this help"
37 echo -e " --develop: install last version for developers, and do not configure as a service"
38 echo -e " --forcedb: reinstall mano_db DB, deleting previous database and creating a new one"
39 echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo"
40 echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation"
41 }
42
43 function install_packages(){
44 [ -x /usr/bin/apt-get ] && apt-get install -y $*
45 [ -x /usr/bin/yum ] && yum install -y $*
46
47 #check properly installed
48 for PACKAGE in $*
49 do
50 PACKAGE_INSTALLED="no"
51 [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
52 [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
53 if [ "$PACKAGE_INSTALLED" = "no" ]
54 then
55 echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2
56 exit 1
57 fi
58 done
59 }
60
61 function db_exists() {
62 RESULT=`mysqlshow --defaults-extra-file="$2" | grep -v Wildcard | grep -o $1`
63 if [ "$RESULT" == "$1" ]; then
64 echo " DB $1 exists"
65 return 0
66 fi
67 echo " DB $1 does not exist"
68 return 1
69 }
70
71 GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
72 DBUSER="root"
73 DBPASSWD=""
74 DBPASSWD_PARAM=""
75 QUIET_MODE=""
76 DEVELOP=""
77 FORCEDB=""
78 NOCLONE=""
79 NO_PACKAGES=""
80 while getopts ":u:p:hiq-:" o; do
81 case "${o}" in
82 u)
83 export DBUSER="$OPTARG"
84 ;;
85 p)
86 export DBPASSWD="$OPTARG"
87 export DBPASSWD_PARAM="-p$OPTARG"
88 ;;
89 q)
90 export QUIET_MODE=yes
91 export DEBIAN_FRONTEND=noninteractive
92 ;;
93 h)
94 usage && exit 0
95 ;;
96 -)
97 [ "${OPTARG}" == "help" ] && usage && exit 0
98 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
99 [ "${OPTARG}" == "forcedb" ] && FORCEDB="y" && continue
100 [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue
101 [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue
102 [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue
103 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
104 exit 1
105 ;;
106 \?)
107 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
108 exit 1
109 ;;
110 :)
111 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
112 exit 1
113 ;;
114 *)
115 usage >&2
116 exit 1
117 ;;
118 esac
119 done
120
121 #check root privileges and non a root user behind
122 [ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
123 if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]]
124 then
125 [[ -z $QUIET_MODE ]] && read -e -p "Install in the root user (y/N)?" KK
126 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
127 export SUDO_USER=root
128 fi
129
130 #Discover Linux distribution
131 #try redhat type
132 [ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
133 #if not assuming ubuntu type
134 [ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null)
135 if [ "$_DISTRO" == "Ubuntu" ]
136 then
137 _RELEASE=$(lsb_release -rs)
138 if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]]
139 then
140 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)'? (y/N)" KK
141 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
142 _RELEASE = 14
143 fi
144 elif [ "$_DISTRO" == "CentOS" ]
145 then
146 _RELEASE="7"
147 if ! cat /etc/redhat-release | grep -q "7."
148 then
149 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested CentOS version. Continue assuming a '_RELEASE' type? (y/N)" KK
150 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
151 fi
152 elif [ "$_DISTRO" == "Red" ]
153 then
154 _RELEASE="7"
155 if ! cat /etc/redhat-release | grep -q "7."
156 then
157 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Red Hat OS version. Continue assuming a '_RELEASE' type? (y/N)" KK
158 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
159 fi
160 else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ]
161 _DISTRO_DISCOVER=$_DISTRO
162 [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14"
163 [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7"
164 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type? (y/N)" KK
165 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
166 fi
167
168
169
170 if [[ -z "$NO_PACKAGES" ]]
171 then
172 echo '
173 #################################################################
174 ##### UPDATE REPOSITORIES #####
175 #################################################################'
176 [ "$_DISTRO" == "Ubuntu" ] && apt-get update -y
177
178 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y
179 [ "$_DISTRO" == "CentOS" ] && sudo yum install -y epel-release
180 [ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \
181 && sudo rpm -ivh epel-release-7-5.noarch.rpm && sudo yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm
182 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && sudo yum repolist
183
184 fi
185
186 if [[ -z "$NO_PACKAGES" ]]
187 then
188 echo '
189 #################################################################
190 ##### INSTALL REQUIRED PACKAGES #####
191 #################################################################'
192 [ "$_DISTRO" == "Ubuntu" ] && install_packages "git screen wget mysql-server"
193 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git screen wget mariadb mariadb-server"
194
195 if [[ "$_DISTRO" == "Ubuntu" ]]
196 then
197 #start services. By default CentOS does not start services
198 service mysql start >> /dev/null
199 # try to set admin password, ignore if fails
200 [[ -n $DBPASSWD ]] && mysqladmin -u $DBUSER -s password $DBPASSWD
201 fi
202
203 if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
204 then
205 #start services. By default CentOS does not start services
206 service mariadb start
207 service httpd start
208 systemctl enable mariadb
209 systemctl enable httpd
210 read -e -p "Do you want to configure mariadb (recommended if not done before) (Y/n)" KK
211 [ "$KK" != "n" -a "$KK" != "no" ] && mysql_secure_installation
212
213 read -e -p "Do you want to set firewall to grant web access port 80,443 (Y/n)" KK
214 [ "$KK" != "n" -a "$KK" != "no" ] &&
215 firewall-cmd --permanent --zone=public --add-service=http &&
216 firewall-cmd --permanent --zone=public --add-service=https &&
217 firewall-cmd --reload
218 fi
219 fi #[[ -z "$NO_PACKAGES" ]]
220
221 #check and ask for database user password. Must be done after database installation
222 if [[ -n $QUIET_MODE ]]
223 then
224 echo -e "\nCheking database connection and ask for credentials"
225 while ! mysqladmin -s -u$DBUSER $DBPASSWD_PARAM status >/dev/null
226 do
227 [ -n "$logintry" ] && echo -e "\nInvalid database credentials!!!. Try again (Ctrl+c to abort)"
228 [ -z "$logintry" ] && echo -e "\nProvide database credentials"
229 read -e -p "database user? ($DBUSER) " DBUSER_
230 [ -n "$DBUSER_" ] && DBUSER=$DBUSER_
231 read -e -s -p "database password? (Enter for not using password) " DBPASSWD_
232 [ -n "$DBPASSWD_" ] && DBPASSWD="$DBPASSWD_" && DBPASSWD_PARAM="-p$DBPASSWD_"
233 [ -z "$DBPASSWD_" ] && DBPASSWD="" && DBPASSWD_PARAM=""
234 logintry="yes"
235 done
236 fi
237
238 if [[ -z "$NO_PACKAGES" ]]
239 then
240 echo '
241 #################################################################
242 ##### INSTALL PYTHON PACKAGES #####
243 #################################################################'
244 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev python-pip"
245 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel python-pip"
246
247 #required for vmware connector TODO move that to separete opt in install script
248 sudo pip install --upgrade pip
249 sudo pip install pyvcloud
250 sudo pip install progressbar
251 sudo pip install prettytable
252
253 #The only way to install python-bottle on Centos7 is with easy_install or pip
254 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle
255
256 #install openstack client needed for using openstack as a VIM
257 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient python-neutronclient"
258 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install python-novaclient python-keystoneclient python-glanceclient python-neutronclient #TODO revise if gcc python-pip is needed
259 fi #[[ -z "$NO_PACKAGES" ]]
260
261 if [[ -z $NOCLONE ]]; then
262 echo '
263 #################################################################
264 ##### DOWNLOAD SOURCE #####
265 #################################################################'
266 su $SUDO_USER -c 'git clone '"${GIT_URL}"' openmano'
267 su $SUDO_USER -c 'cp openmano/.gitignore-common openmano/.gitignore'
268 [[ -z $DEVELOP ]] && su $SUDO_USER -c 'git checkout tags/v1.0'
269 fi
270
271 echo '
272 #################################################################
273 ##### CREATE DATABASE #####
274 #################################################################'
275 echo -e "\nCreating temporary file form MYSQL installation and initialization"
276 TEMPFILE="$(mktemp -q --tmpdir "installopenmano.XXXXXX")"
277 trap 'rm -f "$TEMPFILE"' EXIT
278 chmod 0600 "$TEMPFILE"
279 cat >"$TEMPFILE" <<EOF
280 [client]
281 user=$DBUSER
282 password=$DBPASSWD
283 EOF
284
285 if db_exists "mano_db" $TEMPFILE ; then
286 if [[ -n $FORCEDB ]]; then
287 echo " Deleting previous database mano_db"
288 DBDELETEPARAM=""
289 [[ -n $QUIET_MODE ]] && DBDELETEPARAM="-f"
290 mysqladmin --defaults-extra-file=$TEMPFILE -s drop mano_db $DBDELETEPARAM || ! echo "Could not delete mano_db database" || exit 1
291 #echo "REVOKE ALL PRIVILEGES ON mano_db.* FROM 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
292 #echo "DELETE USER 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
293 mysqladmin --defaults-extra-file=$TEMPFILE -s create mano_db || ! echo "Error creating mano_db database" || exit 1
294 echo "DROP USER 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
295 echo "CREATE USER 'mano'@'localhost' identified by 'manopw';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
296 echo "GRANT ALL PRIVILEGES ON mano_db.* TO 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
297 echo " Database 'mano_db' created, user 'mano' password 'manopw'"
298 else
299 echo "Database exists. Use option '--forcedb' to force the deletion of the existing one" && exit 1
300 fi
301 else
302 mysqladmin -u$DBUSER $DBPASSWD_PARAM -s create mano_db || ! echo "Error creating mano_db database" || exit 1
303 echo "CREATE USER 'mano'@'localhost' identified by 'manopw';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
304 echo "GRANT ALL PRIVILEGES ON mano_db.* TO 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
305 echo " Database 'mano_db' created, user 'mano' password 'manopw'"
306 fi
307
308
309 #Next operations require knowing OPENMANO_BASEFOLDER
310 HERE=$(realpath $(dirname $0))
311 if [[ -z $NOCLONE ]]; then
312 OPENMANO_BASEFOLDER="${HERE}/openmano"
313 else
314 OPENMANO_BASEFOLDER=$(dirname $HERE)
315 fi
316
317
318 echo '
319 #################################################################
320 ##### INIT DATABASE #####
321 #################################################################'
322 su $SUDO_USER -c "${OPENMANO_BASEFOLDER}"'/database_utils/init_mano_db.sh -u mano -p manopw -d mano_db' || ! echo "Failed while initializing database" || exit 1
323
324
325 if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
326 then
327 echo '
328 #################################################################
329 ##### CONFIGURE firewalld #####
330 #################################################################'
331 KK=yes
332 [[ -z $QUIET_MODE ]] && read -e -p "Configure firewalld for openmanod port 9090? (Y/n)" KK
333 if [ "$KK" != "n" -a "$KK" != "no" ]
334 then
335 #Creates a service file for openmano
336 echo '<?xml version="1.0" encoding="utf-8"?>
337 <service>
338 <short>openmanod</short>
339 <description>openmanod service</description>
340 <port protocol="tcp" port="9090"/>
341 </service>' > /etc/firewalld/services/openmanod.xml
342 #put proper permissions
343 pushd /etc/firewalld/services > /dev/null
344 restorecon openmanod.xml
345 chmod 640 openmanod.xml
346 popd > /dev/null
347 #Add the openmanod service to the default zone permanently and reload the firewall configuration
348 firewall-cmd --permanent --add-service=openmanod > /dev/null
349 firewall-cmd --reload > /dev/null
350 echo "done."
351 else
352 echo "skipping."
353 fi
354 fi
355
356 echo '
357 #################################################################
358 ##### CONFIGURE OPENMANO CLIENT #####
359 #################################################################'
360 #creates a link at ~/bin
361 su $SUDO_USER -c 'mkdir -p ${HOME}/bin'
362 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano'
363 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report'
364 su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano'
365 su $SUDO_USER -c 'ln -s '${OPENMANO_BASEFOLDER}'/openmano ${HOME}/bin/openmano'
366 su $SUDO_USER -c 'ln -s '${OPENMANO_BASEFOLDER}'/scripts/openmano-report.sh ${HOME}/bin/openmano-report'
367 su $SUDO_USER -c 'ln -s '${OPENMANO_BASEFOLDER}'/scripts/service-openmano.sh ${HOME}/bin/service-openmano'
368
369 #insert /home/<user>/bin in the PATH
370 #skiped because normally this is done authomatically when ~/bin exist
371 #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin"
372 #then
373 # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc"
374 # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc'
375 #fi
376 if [[ $SUDO_USER == root ]]
377 then
378 if ! echo $PATH | grep -q "${HOME}/bin"
379 then
380 echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc
381 fi
382 fi
383
384 #configure arg-autocomplete for this user
385 #in case of minimal instalation this package is not installed by default
386 [[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion
387 #su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d'
388 su $SUDO_USER -c 'activate-global-python-argcomplete --user'
389 if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc'
390 then
391 echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc"
392 su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc'
393 fi
394
395
396
397
398 if [[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]]
399 then
400 echo '
401 #################################################################
402 ##### CONFIGURE OPENMANO SERVICE #####
403 #################################################################'
404
405 ${OPENMANO_BASEFOLDER}/scripts/install-openmano-service.sh -f ${OPENMANO_BASEFOLDER} #-u $SUDO_USER
406 # alias service-openmano="service openmano"
407 # echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc
408
409 echo
410 echo "Done! you may need to logout and login again for loading client configuration"
411 echo " Manage server with 'service openmano start|stop|status|...' "
412
413
414 else
415
416 echo
417 echo "Done! you may need to logout and login again for loading client configuration"
418 echo " Run './openmano/scripts/service-openmano.sh start' for starting openmano in a screen"
419
420 fi
421
422
423